"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var eui_1 = require("@elastic/eui");
var theme_commons_1 = require("./theme_commons");
exports.LIGHT_THEME = {
    chartPaddings: theme_commons_1.DEFAULT_CHART_PADDING,
    chartMargins: theme_commons_1.DEFAULT_CHART_MARGINS,
    lineSeriesStyle: {
        line: {
            stroke: theme_commons_1.DEFAULT_MISSING_COLOR,
            strokeWidth: 1,
            visible: true,
        },
        border: {
            stroke: 'gray',
            strokeWidth: 2,
            visible: false,
        },
        point: {
            visible: true,
            radius: 1,
            stroke: 'white',
            strokeWidth: 0.5,
            opacity: 1,
        },
    },
    areaSeriesStyle: {
        area: {
            fill: theme_commons_1.DEFAULT_MISSING_COLOR,
            visible: true,
            opacity: 0.8,
        },
        line: {
            stroke: theme_commons_1.DEFAULT_MISSING_COLOR,
            strokeWidth: 1.5,
            visible: true,
        },
        border: {
            stroke: 'gray',
            strokeWidth: 2,
            visible: false,
        },
        point: {
            visible: true,
            radius: 1,
            stroke: 'white',
            strokeWidth: 0.5,
            opacity: 1,
        },
    },
    barSeriesStyle: {
        border: {
            stroke: 'white',
            strokeWidth: 1,
            visible: false,
        },
        displayValue: {
            fontSize: 10,
            fontStyle: 'normal',
            fontFamily: "'Open Sans', Helvetica, Arial, sans-serif",
            padding: 0,
            fill: 'gray',
            offsetX: 0,
            offsetY: 0,
        },
    },
    sharedStyle: theme_commons_1.DEFAULT_GEOMETRY_STYLES,
    scales: {
        barsPadding: 0.25,
    },
    axes: {
        axisTitleStyle: {
            fontSize: 12,
            fontStyle: 'bold',
            fontFamily: "'Open Sans', Helvetica, Arial, sans-serif",
            padding: 5,
            fill: 'gray',
        },
        axisLineStyle: {
            stroke: 'gray',
            strokeWidth: 1,
        },
        tickLabelStyle: {
            fontSize: 10,
            fontFamily: "'Open Sans', Helvetica, Arial, sans-serif",
            fontStyle: 'normal',
            fill: 'gray',
            padding: 0,
        },
        tickLineStyle: {
            stroke: 'gray',
            strokeWidth: 1,
        },
    },
    colors: {
        vizColors: eui_1.palettes.euiPaletteColorBlind.colors,
        defaultVizColor: theme_commons_1.DEFAULT_MISSING_COLOR,
    },
    legend: {
        verticalWidth: 160,
        horizontalHeight: 64,
    },
    crosshair: {
        band: {
            fill: 'lightgray',
            visible: true,
        },
        line: {
            stroke: 'gray',
            strokeWidth: 1,
            dash: [5, 5],
            visible: true,
        },
    },
};
//# sourceMappingURL=light_theme.js.map